%define oname	hybrid-v35
%define dwver	6_30_223_248
%define kname	wl

Summary:	Proprietary driver for Broadcom wireless adapters
Name:		broadcom-wl
Version:	6.30.223.248
Release:	%mkrel 4
Source0:	http://www.broadcom.com/docs/linux_sta/%{oname}-nodebug-pcoem-%{dwver}.tar.gz
Source1:	http://www.broadcom.com/docs/linux_sta/%{oname}_64-nodebug-pcoem-%{dwver}.tar.gz
Source2:	broadcom-wl-blacklist.conf
Source3:	broadcom-wl-alias.conf
Source4:	linux42.patch
Patch1:		linux-recent.patch
Patch2:		license.patch
Patch3:		gcc.patch
License:	Freeware and GPLv2 with exception
Group:		System/Kernel and hardware
URL:		http://www.broadcom.com/support/802.11/linux_sta.php


%description
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n dkms-%{name}
Summary:	Kernel module for Broadcom wireless adapters
Group:		System/Kernel and hardware
Provides:	kmod(%{kname}.ko) = %{version}
Requires(post):		dkms
Requires(preun):	dkms
Requires:	broadcom-wl-blacklist

%description -n dkms-%{name}
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%prep
%ifarch x86_64
%setup -q -T -c -a1 %{oname}
%else
%setup -q -T -c -a0 %{oname}
%endif

%apply_patches


%build

%install
rm -rf %{buildroot}

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp -R * %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
MAKE="make -C \$kernel_source_dir M=\\\$(pwd)"
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
DEST_MODULE_LOCATION=/kernel/3rdparty/%{name}
PATCH[0]="linux42.patch"
PATCH_MATCH[0]="4\.4\.[1-9]"
BUILT_MODULE_NAME=%{kname}
AUTOINSTALL=yes
EOF

install -Dm644 %{SOURCE4} %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/patches/linux42.patch

%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release}

%preun -n dkms-%{name}
# rmmod can fail
/sbin/rmmod %{kname} >/dev/null 2>&1 ||:
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || :

%posttrans
if [ -z "$DURING_INSTALL" ] ; then
    /sbin/rmmod b43 >/dev/null 2>&1 ||:
    /sbin/rmmod b43legacy >/dev/null 2>&1 ||:
    /sbin/rmmod brcmfmac >/dev/null 2>&1 ||:
    /sbin/rmmod brcmsmac >/dev/null 2>&1 ||:
    /sbin/rmmod bcma >/dev/null 2>&1 ||:
    /sbin/rmmod ssb >/dev/null 2>&1 ||:
    /sbin/modprobe wl >/dev/null 2>&1 ||:
fi

%clean
rm -rf %{buildroot}

%files -n dkms-%{name}
%doc lib/LICENSE.txt
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*


%changelog
* Mon Feb 01 2016 bb <bb> 6.30.233.248-4pclos2016
- patch for kernel 4.1.x and 4.4.x fix

* Wed Sep 30 2015 bb <bb> 6.30.233.248-3pclos2015
- update for kernel 4.2.x

* Thu Apr 30 2015 bb <bb> 6.30.223.248-2pclos2015
- update for kernel 4.0.x

* Wed Dec 17 2014 bb <bb> 6.30.223.248-1pclos2014
- update for kernel 3.18
